{ Zaklady operacnich systemu
  --------------------------
  Zadani cislo 1:
   - dynamicka sekce
   - BEST FIT
   - prioritni pridelovani procesoru

  Jan Amler, 3. rocnik FAV,
  amler@students.zcu.cz, http://agentka.kgb.cz/

  posledni uprava: 20.11.2000

  Testovano na : - Free Pascal Compiler verze 1.0.2 [2000/10/12] pro i386
                 - Turbo Pascal verze 7.0                                 

  pozn.: hvezdicka v komentari znaci testovaci kod, neni nutny k behu
         programu, vznikl pri testovani
}

{DEFINE FPC}
uses Crt, Graph;

{*}const Preskoc = -1;{*}

type TypPCB = record { process control block }
                ID       : string[8];
                Pamet    : word;
                Cas      : word;
                Priorita : byte;
              end;

     PFrontaProcesu = ^TFrontaProcesu;
     TFrontaProcesu = record
                        Proces : TypPCB;
                        Dalsi  : PFrontaProcesu;
                      end;

     TPristup = (Pouzivana, Volna);
     PSekce = ^TSekce;
     TSekce = record
                Velikost   : word;
                Pristup    : TPristup;
                Nazev      : string[8]; { pouze k nazornosti }
                Cas        : word;
                Pred, Nasl : PSekce;
              end;

var VrcholFronty, FrontaProcesu : PFrontaProcesu;
    VrcholPameti, Pamet : PSekce;
    Splneno, Konec : boolean;
    GlobalniCas : word;

    NazevVstupu : string;
    MaxPamet    : word; { v kB }

    grDriver, grMode, ErrCode : integer;

procedure NactiProcesy;
var Radka, Temp : string;
    TempP : PFrontaProcesu;
    PCB   : TypPCB;
    Chyba : integer;
    I     : byte;
    VstupniSoubor : text;

begin
  Assign (VstupniSoubor, NazevVstupu);
  Reset (VstupniSoubor);
  while not Eof (VstupniSoubor) do
    begin
      { nacti jednu radku ze vstupu : }
      ReadLn (VstupniSoubor, Radka);
      Radka := Radka + ' '; { uprava kvuli poslednimu cyklu v rozkladu radku,
                              mezera je pouzita jako oddelovac }
      { rozklad radky do datoveho typu popisujiciho proces :
        jakekoli chyby zatim neosetreny ! }
      I := 1;
      PCB.ID := '';
      while Radka[I] <> ' ' do             { \              }
        begin                              {  |             }
          PCB.ID := PCB.ID + Radka[I];     {  > vykousni ID }
          I := I + 1;                      {  |             }
        end;                               { /              }
      Temp := '';
      while Radka[I] = ' ' do I := I + 1;
      while Radka[I] <> ' ' do
        begin
          Temp := Temp + Radka[I];
          I := I + 1;
        end;
      Val (Temp, PCB.Pamet, Chyba);
      Temp := '';
      while Radka[I] = ' ' do I := I + 1;
      while Radka[I] <> ' ' do
        begin
          Temp := Temp + Radka[I];
          I := I + 1;
        end;
      Val (Temp, PCB.Cas, Chyba);
      Temp := '';
      while Radka[I] = ' ' do I := I + 1;
      while Radka[I] <> ' ' do
        begin
          Temp := Temp + Radka[I];
          I := I + 1;
        end;
      Val (Temp, PCB.Priorita, Chyba);
      { ... dokoncen rozklad radky ze vstupu }

      { zatridovani procesu do fronty podle priority : }
      if FrontaProcesu = nil then
        begin
          New (FrontaProcesu);
          FrontaProcesu^.Proces := PCB;
          FrontaProcesu^.Dalsi := nil;
          VrcholFronty := FrontaProcesu;
        end
        else
        begin
          FrontaProcesu := VrcholFronty;
          while (PCB.Priorita <= FrontaProcesu^.Proces.Priorita)
                and (FrontaProcesu^.Dalsi <> nil) do
                  FrontaProcesu := FrontaProcesu^.Dalsi;
          if PCB.Priorita <= FrontaProcesu^.Proces.Priorita then
            begin
              New (FrontaProcesu^.Dalsi);
              FrontaProcesu := FrontaProcesu^.Dalsi;
              FrontaProcesu^.Proces := PCB;
              FrontaProcesu^.Dalsi := nil;
            end
            else
            begin
              New (TempP);
              TempP^ := FrontaProcesu^;
              FrontaProcesu^.Proces := PCB;
              FrontaProcesu^.Dalsi := TempP;
            end;
        end;
    end;
end;

procedure InicializujPamet;
begin
  New (VrcholPameti);
  with VrcholPameti^ do
    begin
      Velikost := MaxPamet;
      Pristup := Volna;
      Pred := nil;
      Nasl := nil;
    end;
end;

procedure KresliStav;
var Pmt : PSekce;
    X, Xd : word;
    Ch : char;
    FP : PFrontaProcesu;

function I2S (I: word) : string;
var S : string;
begin
  Str(I, S);
  I2S := S;
end;

begin
  ClearDevice;
  SetColor (DarkGray);
  Line (10, 80, 610, 80);
  SetColor (LightGray);
  for X:=0 to MaxPamet do
    begin
      Line (10+Round(X*(600/MaxPamet)), 78, 10+Round(X*(600/MaxPamet)), 82);
      OutTextXY (10+Round(X*(600/MaxPamet)), 83, I2S(X));
    end;
  SetColor (White);
  OutTextXY (610, 83, I2S(MaxPamet));
  OutTextXY (610, 93, 'kB');
  SetTextStyle (0, 0, 1);
  OutTextXY (0,0, 'Cas : '+I2S(GlobalniCas)+' min. od zacatku');
  SetTextStyle (0, 1, 1);

  { nacrtni pamet : }
  Pmt := VrcholPameti;
  X := 10;
  while Pmt <> nil do
    begin
      if Pmt^.Pristup = Volna then SetFillStyle (SolidFill, Blue)
                              else SetFillStyle (SolidFill, LightRed);
      Xd := X + Round (Pmt^.Velikost * (600 / MaxPamet)); { bez zavorek preteka ?}
      Bar (X, 20, Xd, 60);
      Rectangle (X, 20, Xd, 60);
      if Pmt^.Pristup = Pouzivana then
        begin
          OutTextXY (X+9, 20, Pmt^.Nazev);
          OutTextXY (X+19, 20, I2S(Pmt^.Cas));
        end;
      X := Xd;
      Pmt := Pmt^.Nasl;
    end;

  {* kontrola "Pred" :
  Pmt := VrcholPameti;
  while Pmt^.Nasl <> nil do Pmt := Pmt^.Nasl;
  X := 610;
  while Pmt <> nil do
    begin
      if Pmt^.Pristup = Volna then SetFillStyle (SolidFill, Blue)
                              else SetFillStyle (SolidFill, LightRed);
      Xd := X - Round (Pmt^.Velikost * (600 / MaxPamet));
      Bar (X, 120, Xd, 160);
      Rectangle (X, 120, Xd, 160);
      if Pmt^.Pristup = Pouzivana then
        begin
          OutTextXY (Xd+9, 120, Pmt^.Nazev);
          OutTextXY (Xd+19, 120, I2S(Pmt^.Cas));
        end;
      X := Xd;
      Pmt := Pmt^.Pred;
    end;
  {*}

  SetTextStyle (0, 0, 1);

  X := 100; { v tomhle pripade je X spis Y }
  OutTextXY (10, X, 'Fronta procesu : ');
  X := X + 10;
  FP := VrcholFronty;
  while FP <> nil do
    begin
      with FP^.Proces do
        OutTextXY (20, X, ID+' - '+I2S(Priorita)+', '+I2S(Cas)+'min '+
                          I2S(Pamet)+'kB');
      FP := FP^.Dalsi;
      X := X + 10;
    end;

  OutTextXY (350,430, '<Esc> ukonci program');
  OutTextXY (350,440, 'libovolna jina klavesa posune cas');

  Ch := ReadKey;
  if Ch = #27 then Konec := True;
end;

function PridelPamet (ZFronty : PFrontaProcesu) : boolean;
var Best : record
             Velikost : word;
             Kde      : PSekce;
           end;
    Pamet, Temp : PSekce;

begin
  { implementace BEST FIT : }
  Best.Velikost := MaxPamet + 1; { prvotni BEST je ten nejhorsi }
  Best.Kde := nil;

  Pamet := VrcholPameti;
  repeat { opakuj pro vsechny sekce }
    if (Pamet^.Pristup = Volna) and           { jestlize je sekce volna }
       (ZFronty^.Proces.Pamet <= Pamet^.Velikost) and { proces se do ni vejde }
       (Pamet^.Velikost < Best.Velikost) then { a je mensi ... }
       begin
         Best.Velikost := Pamet^.Velikost; { ... pak je prozatim }
         Best.Kde := Pamet;                { nejlepsi kandidat. }
       end;
    Pamet := Pamet^.Nasl;
  until Pamet = nil;

  if Best.Kde = nil then PridelPamet := False { proces se nikam nevejde }
    else
    begin
      { velikost volne sekce a procesu se nerovnaji, musime sekci rozdelit: }
      if Best.Kde^.Velikost <> ZFronty^.Proces.Pamet then
        begin
          { rozdelme sekce na obsazenou procesem a novou volnou }
          Temp := Best.Kde^.Nasl;
          New (Best.Kde^.Nasl);
          { pro novou volnou sekci plati : }
          Best.Kde^.Nasl^.Velikost := Best.Kde^.Velikost - ZFronty^.Proces.Pamet;
          Best.Kde^.Nasl^.Pristup := Volna;
          Best.Kde^.Nasl^.Pred := Best.Kde;
          Best.Kde^.Nasl^.Nasl := Temp;
          { tadyten radek chybel do posledni chvile (na jeden ukazatel jsem zapomnel) }
          Temp^.Pred := Best.Kde^.Nasl;
          { pro sekci obsazenou procesem plati : }
          Best.Kde^.Velikost := ZFronty^.Proces.Pamet;
        end;
      Best.Kde^.Pristup := Pouzivana;
      Best.Kde^.Nazev := ZFronty^.Proces.ID;
      Best.Kde^.Cas := ZFronty^.Proces.Cas;
      { predchozi se nedefinuje ?  a Nasl uz je Newvlej }
      PridelPamet := True;
    end;
end;

procedure UvolniPamet (Pamet : PSekce);
var Temp : PSekce;
begin
  Pamet^.Pristup := Volna;

  if (Pamet^.Pred <> nil)                    { jestli existuje neco vlevo }
     and (Pamet^.Pred^.Pristup = Volna) then { a je to volny, }
     begin                                   { chtelo by to sloucit }
       Pamet^.Velikost := Pamet^.Velikost + Pamet^.Pred^.Velikost;
       if Pamet^.Pred^.Pred = nil then { sekce, kterou pripojuji je prvni }
         begin
           Dispose (VrcholPameti);
           VrcholPameti := Pamet;
           Pamet^.Pred := nil;
         end
         else
         begin
           Temp := Pamet^.Pred;
           Pamet^.Pred := Temp^.Pred; { naslednost se posune }
           Temp^.Pred^.Nasl := Pamet;
           Dispose (Temp); { takze tady uz je ten vice vpravo }
         end;
     end;

  if (Pamet^.Nasl <> nil)                    { jestli existuje neco vpravo }
     and (Pamet^.Nasl^.Pristup = Volna) then { a je to volny, }
     begin                                   { chtelo by to sloucit }
       Pamet^.Velikost := Pamet^.Velikost + Pamet^.Nasl^.Velikost;
       if Pamet^.Nasl^.Nasl = nil then { sekce, kterou pripojuji je posledni}
         begin
           Dispose (Pamet^.Nasl);
           Pamet^.Nasl := nil;
         end
         else
         begin
           Temp := Pamet^.Nasl;
           Pamet^.Nasl := Temp^.Nasl; { naslednost se posune }
           Temp^.Nasl^.Pred := Pamet;
           Dispose (Temp); { takze tady uz je ten vice vpravo }
         end;
     end;
end;

begin
  ClrScr;
  Write ('Zadejte nazev vstupniho souboru : ');
  ReadLn (NazevVstupu);

  Write ('Zadejte velikost pameti : ');
  ReadLn (MaxPamet);

{  NazevVstupu := 'BATCH';
   MaxPamet := 50;
}

  NactiProcesy;
  InicializujPamet;

  { inicializace grafiky : }
{$IFDEF FPC}
  grDriver := D8bit;
  grMode := m640x480;
{$ELSE}
  grDriver := Detect;
{$ENDIF}
  InitGraph (grDriver, grMode, '');
  ErrCode := GraphResult;
  if ErrCode <> grOk then
    begin
      Writeln('Graphics error #',ErrCode,': ', GraphErrorMsg(ErrCode));
      Halt;
    end;

  KresliStav;

  { inicializace casu : }
  GlobalniCas := 0;
  repeat
    { nasyp maximum procesu do pameti : }
    FrontaProcesu := VrcholFronty;
    repeat
      { pridel pamet (mozno pouze procesu na vrcholu fronty) : }
      Splneno := PridelPamet (FrontaProcesu);
      if Splneno then
        begin
          { zlikviduj proces z fronty : }
          FrontaProcesu := FrontaProcesu^.Dalsi;
          Dispose (VrcholFronty);
          VrcholFronty := FrontaProcesu;
        end;
    { skonci, kdyz neni volne misto nebo jsme vycerpali frontu }
    until (not Splneno) or (FrontaProcesu = nil);

    {*}if GlobalniCas > Preskoc then{*} KresliStav;

    { casova obratka pro vsechny sekce naraz : }
    Pamet := VrcholPameti;
    while Pamet <> nil do
      begin
        if Pamet^.Pristup = Pouzivana then { pro pouzivane odecti cas : }
          begin
            Pamet^.Cas := Pamet^.Cas - 1;
            { pokud se proces dokoncil, uvolni pamet : }
            if Pamet^.Cas < 1 {resp. = 0} then UvolniPamet (Pamet);
          end;
        Pamet := Pamet^.Nasl;
      end;
    { tok casu : }

    GlobalniCas := GlobalniCas + 1;
  until Konec;

  CloseGraph;

  { zruseni fronty procesu : }
  FrontaProcesu := VrcholFronty;
  while FrontaProcesu <> nil do
    begin
      FrontaProcesu := FrontaProcesu^.Dalsi;
      Dispose (VrcholFronty);
      VrcholFronty := FrontaProcesu;
    end;

  { zruseni sekci : }
  Pamet := VrcholPameti;
  while Pamet <> nil do
    begin
      Pamet := Pamet^.Nasl;
      Dispose (VrcholPameti);
      VrcholPameti := Pamet;
    end;
end.